#include "inputfield.hh"

class InputLine : public InputField
{
    Screen::ScreenRegion region;
    unsigned max, promptlen;
    unsigned curspos, xpos, blockbegin, blockend;
    string result;
    bool insertmode;
    
    void cleartext();
    
    void va_init(const char *fmt, va_list ap)
    {
        cleartext();
        insertmode = true;
        unsigned len = region.printf(fmt, ap);
        
        promptlen = len;        
        max = region.xsize() - 1 - len;
        
        redraw();
    }    
public:
    InputLine(const char *fmt, va_list ap) : region(Display.AllocateLine(true))
    {
        va_init(fmt, ap);
    }
    InputLine(const char *fmt...) PRNATTR(1) : region(Display.AllocateLine(true))
    {
        va_list ap;
        va_start(ap, fmt);
        va_init(fmt, ap);
        va_end(ap);
    }
    InputLine(unsigned width, const char *fmt, va_list ap) : region(Display.AllocateLine(width, true))
    {
        va_init(fmt, ap);
    }
    InputLine(unsigned width, const char *fmt...) PRNATTR(2) : region(Display.AllocateLine(width, true))
    {
        va_list ap;
        va_start(ap, fmt);
        va_init(fmt, ap);
        va_end(ap);
    }
    ~InputLine()
    {
        Display.UnderlineCursor();
    }
    void SetResult(const string &s) { result = s; redraw(); }
    inline const string &GetResult() const { return result; }
    
    virtual bool Handle(const InputEvent &ev);
    virtual void redraw();
};
